package info.textgrid.middleware;

import java.util.Hashtable;
import java.util.List;
import java.util.Map;
import java.util.UUID;

import org.classicmayan.tools.Queries;

import info.textgrid.middleware.oaipmh.ListIdentifiersType;
import info.textgrid.middleware.oaipmh.ResumptionTokenType;

public class IdentifierListDelivererIDIOM extends IdentifierListDelivererAbstract{
	
	static Map<String, Integer> cursorCollector = new Hashtable<String, Integer>();
	
	public IdentifierListDelivererIDIOM(boolean textgrid, boolean dariah) {
		super(textgrid, dariah);
	}
	
	public ListIdentifiersType processIdentifierList(String from, String to, String set, String resumptionToken) {
		ListIdentifiersType lit = new ListIdentifiersType();
		List<String> artefactURIs;
		
		if(resumptionToken==null) {
			artefactURIs = Queries.getArtefactList(0);
		}else {
			System.out.println("RES TOKEN FOUND: " + cursorCollector.get(resumptionToken));
			artefactURIs = Queries.getArtefactList(cursorCollector.get(resumptionToken));			
		}
		
	    long listSize = Queries.getAmountOfArtefacts();	    
	    int i=0;
	    UUID uuid = UUID.randomUUID();
	    String resTokenValue = uuid.toString();
	    resumptionToken = uuid.toString();
		
		for(String artefactURI : artefactURIs) {
			RecordDelivererIDIOM idiomRecord = new RecordDelivererIDIOM(true, false);
		    lit.getHeader().add(idiomRecord.getRecordById(artefactURI).getRecord().getHeader());
		}
		
	    // Check the need for a resumption token!
	    ResumptionTokenType resTokenForResponse = OAIPMHUtillities.getResumptionToken(
	    		  listSize, resumptionToken, cursorCollector, resTokenValue, 30, i);
	    
	    if (resTokenForResponse != null) {
	    	lit.setResumptionToken(resTokenForResponse);
	    }
		
		return lit;
	}
	
}
