package info.textgrid.middleware;


import java.util.Hashtable;
import java.util.List;
import java.util.Map;
import java.util.UUID;

import org.apache.commons.logging.LogFactory;
import org.classicmayan.tools.Queries;

import info.textgrid.middleware.oaipmh.HeaderType;
import info.textgrid.middleware.oaipmh.ListRecordsType;
import info.textgrid.middleware.oaipmh.MetadataType;
import info.textgrid.middleware.oaipmh.RecordType;
import info.textgrid.middleware.oaipmh.ResumptionTokenType;

public class RecordListDelivererIDIOM extends RecordListDelivererAbstract{

	private static org.apache.commons.logging.Log log = LogFactory.getLog(OAIPMHImpl.class);
	static Map<String, Integer> cursorCollector = new Hashtable<String, Integer>();
	
	private OAI_ESClient oaiEsClient;
	
	public RecordListDelivererIDIOM(boolean textgrid, boolean dariah) {
		super(textgrid, dariah);
		// TODO Auto-generated constructor stub
	}

	@Override
	public RecordType buildRecord(ListRecordsType recordList, String set, String headerIdentifier) {
				
	    MetadataType metadata = new MetadataType();
	    RecordType record = new RecordType();

	    record.setMetadata(metadata);
	    recordList.getRecord().add(record);
	    
		return null;
	}

	@Override
	public ListRecordsType getRecords(String from, String to, String set, String resumptionToken) {

		log.info("Started List Records with booleans for DARIAH:  " + this.dariah + " and TextGrid: " + this.textgrid);
		
		ListRecordsType recordList = new ListRecordsType();
		List<String> artefactURIs;
		
		if(resumptionToken==null) {
			artefactURIs = Queries.getArtefactList(0);
		}else {
			artefactURIs = Queries.getArtefactList(cursorCollector.get(resumptionToken));			
		}
	    
	    long listSize = Queries.getAmountOfArtefacts();	    
	    int i=0;
	    
	    UUID uuid = UUID.randomUUID();
	    String resTokenValue = uuid.toString();
	    resumptionToken = uuid.toString();
	    
	    for(String artefactURI : artefactURIs) {
	    	
		    RecordDelivererIDIOM idiomRecord = new RecordDelivererIDIOM(true, false);
		    recordList.getRecord().add(idiomRecord.getRecordById(artefactURI).getRecord());   
		    i++;
	    }

	    // Check the need for a resumption token!
	    ResumptionTokenType resTokenForResponse = OAIPMHUtillities.getResumptionToken(
	    		  listSize, resumptionToken, cursorCollector, resTokenValue, 100, i);
	    
	    if (resTokenForResponse != null) {
	    	recordList.setResumptionToken(resTokenForResponse);
	    }
	    return recordList;
	}

	@Override
	public HeaderType setHeader(String set, String headerIdentifier) {
		// TODO Auto-generated method stub
		return null;
	}

	public OAI_ESClient getOaiEsClient() {
		return oaiEsClient;
	}

	public void setOaiEsClient(OAI_ESClient oaiEsClient) {
		this.oaiEsClient = oaiEsClient;
	}

}
